<?php
/** @var $this CatalogViewCpage */
defined( '_JEXEC' ) or die; // No direct access

//~ use Exception;
use Joomla\CMS\Factory;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Helper\ContentHelper;
use Joomla\CMS\Language\Multilanguage;
use Joomla\CMS\Language\Text;
use Joomla\CMS\MVC\View\GenericDataException;
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Pagination\Pagination;
use Joomla\CMS\Toolbar\Toolbar;
use Joomla\CMS\Toolbar\ToolbarHelper;
//~ use Joomla\Component\Catalog\Administrator\Model\CatalogModel;
use Joomla\Registry\Registry;

ToolbarHelper::title(Text::_('COM_CATALOG'), 'brush catalog');
$toolbar = Toolbar::getInstance('toolbar');

$app = Factory::getApplication();
$user = $app->getIdentity();

if ($user->authorise('core.admin', 'com_catalog') || $user->authorise('core.options', 'com_catalog')){
    $toolbar->preferences('com_catalog');
}

//~ $toolbar->help('Catalog');
\Joomla\CMS\HTML\HTMLHelper::_('bootstrap.modal');

$db = JFactory::getDbo();
//~ $lcaps = $db->setQuery("SELECT * FROM `".DB_LCAP."` WHERE 1 ORDER BY `ord` ASC")->loadObjectList('id');
//~ $types = $db->setQuery("SELECT * FROM `".DB_TYPE."` WHERE 1 ORDER BY `ord` ASC")->loadObjectList('id');
$lcaps = array();
$types = array();

$formName = 'refs';
$form = JForm::getInstance($formName, __DIR__ .'/'.$formName.'.xml');
$form->bind(array(
    $formName => array(
        'lampcaps' => $lcaps,
        'lamptype' => $types,
    )
));
$data = $form->getData()->toObject()->$formName;
//~ func::prn($data);

if(!empty($_REQUEST[$formName])){
    $form->bind($_REQUEST);
    $data = $form->getData()->toObject()->$formName;
    if(!empty($data->lampcaps)){
        $ord = 0;
        foreach($data->lampcaps as $lcap){
            $item = (object)$lcap;
            $item->ord = ++$ord;
            if(empty($item->id)){
                $item->id = null;
                //~ $db->insertObject(DB_LCAP, $item, 'id');
            }else{
                //~ $db->updateObject(DB_LCAP, $item, 'id');
                if(isset($lcaps[$item->id])) unset($lcaps[$item->id]);
            }
        }
        //~ if(!empty($lcaps)) $db->setQuery("DELETE FROM `".DB_LCAP."` WHERE `id` IN ('".implode("', '", array_keys($lcaps))."')")->execute();
    }
    if(!empty($data->lamptype)){
        $ord = 0;
        foreach($data->lamptype as $type){
            $item = (object)$type;
            $item->ord = ++$ord;
            if(empty($item->id)){
                $item->id = null;
                //~ $db->insertObject(DB_TYPE, $item, 'id');
            }else{
                //~ $db->updateObject(DB_TYPE, $item, 'id');
                if(isset($types[$item->id])) unset($types[$item->id]);
            }
        }
        //~ if(!empty($types)) $db->setQuery("DELETE FROM `".DB_TYPE."` WHERE `id` IN ('".implode("', '", array_keys($types))."')")->execute();
    }
    $app->redirect($_SERVER['REQUEST_URI']);
}
?>
<style>
    .item-page .modal .control-label {
        display: none !important;
    }
    .item-page .modal .modal-body .btn {
        margin: 0 !important;
        padding: 0 !important;
    }
    .item-page .modal .modal-body .btn span {
        margin: 0 !important;
        width: 2.375rem !important;
    }
    .item-page .modal th {
        width: auto !important;
    }
    .11item-page .modal td+td+td {
        width: 100%;
    }
    .item-page .modal .control-group,
    .item-page .modal .control-group .controls {
        min-width: 0;
    }
    .item-page .modal .control-group .controls {
        width: 100;
    }
</style>
<div class="item-page">
    <div class="row">
        <div class="col">
            <button type="button" class="btn btn-secondary w-100" data-bs-toggle="modal" data-bs-target="#modalLampCaps">Справочник 1</button>
            <div class="modal fade" id="modalLampCaps" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-hidden="true">
                <div class="modal-dialog modal-dialog-scrollable modal-xl">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="staticBackdropLabel">Справочник 1</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body">
                            <form id="formLampCaps" action="" method="post"><?= $form->renderFieldset('lcaps'); ?></form>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?= JText::_('JCLOSE'); ?></button>
                            <button type="submit" class="btn btn-primary" form="formLampCaps"><?= JText::_('JAPPLY'); ?></button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="col">
            <button type="button" class="btn btn-secondary w-100" data-bs-toggle="modal" data-bs-target="#modalLampType">Справочник 2</button>
            <div class="modal fade" id="modalLampType" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-hidden="true">
                <div class="modal-dialog modal-dialog-scrollable modal-xl">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="staticBackdropLabel">Справочник 2</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body">
                            <form id="formLampType" action="" method="post"><?= $form->renderFieldset('ltype'); ?></form>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?= JText::_('JCLOSE'); ?></button>
                            <button type="submit" class="btn btn-primary" form="formLampType"><?= JText::_('JAPPLY'); ?></button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
